program icz10_DialogBox_02;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDC_EDIT    = 3000;
  IDC_BUTTON  = 3001;
  IDC_EXIT    = 3002;
  IDM_GETTEXT = 32000;
  IDM_CLEAR   = 32001;
  IDM_EXIT    = 32002;

const
  DlgName    = 'MyDialog';
  AppName    = 'Our Second Dialog Box';
  TestString = 'Wow! I''m in an edit box now';

var
  buffer: array [0..511] of Char;

function DlgProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; stdcall;
begin
  Result := True;
  case uMsg of
    WM_INITDIALOG:
      SetFocus(GetDlgItem(hWnd, IDC_EDIT));
    WM_CLOSE:
      SendMessage(hWnd, WM_COMMAND, IDM_EXIT, 0);
    WM_COMMAND:
      if lParam = 0 then
      begin
        case LoWord(wParam) of
          IDM_GETTEXT:
            begin
              GetDlgItemText(hWnd, IDC_EDIT, buffer, 512);
              MessageBox(0, buffer, AppName, MB_OK);
            end;
          IDM_CLEAR:
            SetDlgItemText(hWnd, IDC_EDIT, nil);
          IDM_EXIT:
            EndDialog(hWnd, 0);
        end;
      end else
        if HiWord(wParam) = BN_CLICKED then
        begin
          case LoWord(wParam) of
            IDC_BUTTON:
              SetDlgItemText(hWnd, IDC_EDIT, TestString);
            IDC_EXIT:
              SendMessage(hWnd, WM_COMMAND, IDM_EXIT, 0);
          end;
        end;
  else
    Result := False;
  end;
end;

begin
  DialogBoxParam(HInstance, DlgName, 0, @DlgProc, 0);
end.